library movable_widget;

import 'package:flutter/gestures.dart';
import 'package:flutter/material.dart';
import 'package:flutter/widgets.dart';

/// A Calculator.
class MovableWidget extends StatefulWidget {

  final Widget widget;

  MovableWidget(this.widget);

  @override
  State<StatefulWidget> createState() {
    // TODO: implement createState
    return MovableState(widget);
  }
}

class MovableState extends State<MovableWidget> with SingleTickerProviderStateMixin {
  double _top = 0.0;
  double _left = 0.0;
  Widget child;

  MovableState(this.child);

  @override
  Widget build(BuildContext context) {
    return Stack(
      children: <Widget>[
        Positioned(
          top: _top,
          left: _left,
          child: GestureDetector(
            child: child,
            onPanDown: (DragDownDetails e) {
              print("用户手指按下：${e.globalPosition}");
            },
            onPanUpdate: (DragUpdateDetails e) {
              setState(() {
                _left += e.delta.dx;
                _top += e.delta.dy;
              });
            },
            onPanEnd: (DragEndDetails e) {
              print(e.velocity);
            },
          ),
        )
      ],
    );
  }
}